      program nxnames
c***** read test of ILL NeXus hdf5 file
c /usr/local/hdf5/bin/h5fc -o h5nopp h5nopp.f  h5bits.o
c ~/gg/libsOgf/libpgplot.a -L/usr/X11R6/lib -lX11
c treats 64x64 to 256x256 to 100x128x256
      parameter (NXY=100*256*128)
      
      common/cmdcom/cmd
      common/h5com/v
      common/debh5/ideb
      common/scannxc/igf
      common/scannam/dnames(500)
      common/scannml/nnam,nl(500)
      common/illinst/iinst
      character dnames*100,exam(30)*60
      real v(NXY)
      real vp(NXY)
      integer idim(10),idimi(10)
      integer ii(1024*1024)
      character*80 fname,dsname,gname
      character cmd*80,cm1*1,ttype(3)*10,cinst*3
      character c(1024)*1
      character text*50,text1*50
      logical found
      equivalence(ii,v,c)
      ttype(1)='characters'
      ttype(2)='integer   '
      ttype(3)='real      '
      text=' '
      text1=' '
      iinst=0
      do i=1,30
       exam(i)=' '
      end do
      exam(1)=' '
      exam(2)='/entry0/DNN/detector/pixel_size_x   55 0 7.5'
      exam(3)='/entry0/DNN/detector/pixel_size_y   56 0 7.5'
      exam(4)='/entry0/DNN/selector/wavelength   53'
      exam(5)='/entry0/DNN/detector/det_actual 26'
      exam(6)='/entry0/data1/data1        533'
      exam(7)='/entry0/duration          3     10'
      exam(8)='/entry0/end_time          301'
      exam(9)='/entry0/experiment_title  400'
      exam(10)='/entry0/sample_description 401'  
      exam(11)='/entry0/start_time            300'
      exam(12)='/entry0/run_number   310'
      exam(13)='/entry0/sample/temperature        31'
      exam(14)='/entry0/sample/trs_actual         64'
      exam(15)='/entry0/monitor2/preset    1'
      exam(16)='/entry0/data1/data1        500'
      exam(17)=' ==> note remove # to use uncommented line!'
      exam(18)=' useful ASCII file parameter locations: '
      exam(19)='1 preset_1  3 time(0.1secs)   4 detector_sum'
      exam(20)='5 monitorsum 23 dvm           26 s-det_m'
      exam(21)='29 set_temp_K30 reg_K         31 sample_K'
      exam(22)='51 beamX0 pix 52 beamY0 pix   53 wavelengthA'
      exam(23)='54 dwav/wav   55 dx_pixel_mm  56 dy_pixel_mm'
      exam(24)='15 twotheta   65 omega        64 trs'
      exam(25)='300 starttime 301 endtime     '
      exam(26)='400 experiment title 401 sample description'
      exam(27)='500 detector data (reduced to 128x128 max)'

      do i=1,4
       idim(i)=0
      end do 
5     write(6,1)
1     format(' ILL-NeXus SANS dataset names '/
     1' Give filename [034100.nxs] : ',$)
      inds=0
      ntot=0
      itype=0
      cinst='D11'
      read(5,2) fname
      if(fname.eq.' ') fname='034100.nxs'
      inquire(file=fname,exist=found)
      if(.not.found) call stopms('File not found')
c      write(*,*) found
      lf=len_trim(fname)
      text=fname
      gname=' '
      call scanxs(fname(1:lf),gname)
      call oldh5(ier,id_f,fname(1:lf),'O')
2     format(a)
      idim(1)=1024
      dsname='/entry0/instrument_name'
      ld=len_trim(dsname)
      call readds(ier,id_f,dsname(1:ld),v,ir,idim,iitype)
      if(ier.ne.0) write(*,*) ' No instrument name'
      if(ier.ne.0) call stopms('file read  error')
      write(6,49) (c(i),i=1,3)
49    format(' Instrument is ',3a)
      if(c(2).eq.'1') iinst=1
      if(c(2).eq.'2') iinst=2
      if(c(2).eq.'3') iinst=3
      cinst(2:2)=c(2)
      cinst(3:3)=c(3)
      write(*,*)'There are ',nnam,'  datasets present'
105   continue
c***** list datasets
      do i=1,nnam
      ln=nl(i)
      write(6,106) dnames(i)(2:ln)
106   format(a)
      end do
      open(unit=2,file='nxsnames.nam',status='unknown')
      write(2,118)
118   format
     1('Example of DNNindex.nxf for instrument DNN v1.0 16/09/12'/
     1'dataset_name..output_index..multiply_input..default_value'/
     1'output index 1-100 ascii real parameters'/
     1'             300-400 strings'/
     1'             500-  detector_data'/
     1' Note several names can point to same output location'/
     1' zero output index (blank) skips input'//
     1' file DNNindex.nxf :'/)
     
      do i=18,30
      write(2,109) exam(i)
109   format('#',a)
      end do
      do i=1,17
      write(2,109) exam(i)
      end do
      write(2,108) cinst,fname
108   format(//'# Instrument ',a,' datafile : ',a)
      do i=1,nnam
      ln=nl(i)
      write(2,106) dnames(i)(2:ln)
      end do
      close(2)
      write(6,*)' Dataset names have been written in nxsnames.nam'
c***** allow for dos screen to show text message
      call stopms('finished')
      end
      subroutine stopms(msg)
c***** for prop on MS pause before closing window
      character*(*) msg
      character*20 os
      if(msg.eq.' ') stop
      write(6,*) msg
      call getenv('OS',os)
      if(os.eq.'Windows_NT') call sleep(5)
      stop
      end
